//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    MaPeriod      = 20;
extern int    MaMethod      = MODE_SMA;
extern int    PriceToUse    = PRICE_TYPICAL;
extern int    AtrPeriod     = 150;
extern double AtrMultiplier = 1;
extern int    MaAtrShift    = 1;
extern string MaMethods     = "";
extern string _0            = "0 - SMA";
extern string _1            = "1 - EMA";
extern string _2            = "2 - SMMA";
extern string _3            = "3 - LWMA";
extern string _4            = "4 - TMA";

double bup[];
double bdn[];
double ma[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bup);
   SetIndexBuffer(1,bdn);
   SetIndexBuffer(2,ma);
      IndicatorShortName("Keltner channel ("+MaPeriod+","+DoubleToStr(AtrMultiplier,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double atr = iATR(NULL,0,AtrPeriod,i+MaAtrShift);
         if (MaMethod!=4)
               ma[i]  = iMA(NULL,0,MaPeriod,0,MaMethod,PriceToUse,i+MaAtrShift);
         else  ma[i]  = iTma(iMA(NULL,0,1,0,MODE_SMA,PriceToUse,i+MaAtrShift),MaPeriod,i);
               bup[i] =  ma[i]+AtrMultiplier*atr;
               bdn[i] =  ma[i]-AtrMultiplier*atr;
      }
   return(0);
}

//
//
//
//
//

double workTma[][1];
double iTma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workTma,0)!= Bars) ArrayResize(workTma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workTma[r][instanceNo] = price;

      double half = (period+1.0)/2.0;
      double sum  = price;
      double sumw = 1;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = k+1; if (weight > half) weight = period-k;
                sumw  += weight;
                sum   += weight*workTma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}
